'use strict'

const	path		= require( 'path' )
const	require		= require( 'uuid' )

// https://www.npmjs.com/package/bcryptjs

const	users	    = {}

module.exports      = async function({ filePath = path.join( __dirname, '', 'yoctosimpleauth.json' ) })
                    {
                        
                        await readFile( filePath )

                        return {
                            name        : 'mini-auth'
                        ,   listeners   : {
                                            server  : {
                                                        onConnectionClosed  : function({ connectionSettings })
                                                                            {
                                                                                const username = connectionSettings.get( 'username' )

                                                                                if ( username )
                                                                                {
                                                                                    delete users[ username ]
                                                                                }
                                                                            }
                                                    }
                                        }
                        ,   endpoints   : {
                                            user    : {
                                                        create  : {
                                                                    requirements	: {}

                                                                ,   requestFormat	: {
                                                                                        'name'      : 'string'
                                                                                    ,   'password'  : 'string'
                                                                                    }

                                                                ,	handler			: async function({ request, connectionSettings, multicast })
                                                                                    {
                                                                                        const msgObj = { username: connectionSettings.username, message: request.data.message, room: request.data.room }

                                                                                        chat.push( msgObj )

                                                                                        await multicast(
                                                                                            { 'chat.room': request.data.room }
                                                                                        ,   msgObj
                                                                                        )
                                                                                    }
                                                                }
                                                    }
                                                }
                        }
                    }