'use strict'

const   _       = require( 'lodash' )

module.exports = server =>
({
    name            : 'yoctopus'
,   settings        : {
                        label           : 'string'
                    ,   isSecure        : 'bool'
                    ,   port            : 'number'
                    ,   remoteAddress   : 'string'
                    }
,   endpoints       : {
                        label   : {
                                    update  : {
                                                requestFormat   : 'string'
                                            ,   handler         : function({ connectionSettings, request, log, data })
                                                                {
                                                                    connectionSettings.set( 'label', request.data )
                                                                    log.notice( `Connection to ${ connectionSettings.get( 'yoctopus', 'remoteAddress' ) } labeled "${request.data}"` )
                                                                }
                                            }
                                }
                    }
,   listeners       : {
                        server  : {
                                    onConnectionOpened  : function({ connectionSettings, data })
                                                        {
                                                            connectionSettings.set( 'isSecure', server.isSecure )
                                                            connectionSettings.set( 'port', server.port )
                                                            connectionSettings.set( 'remoteAddress', data.remoteAddress )
                                                        }
                                ,   onConnectionClosed  : function({ connectionSettings, log })
                                                        {
                                                            const label = connectionSettings.get( 'yoctopus', 'label' )

                                                            if ( label )
                                                            {
                                                                log.notice( `Connection labeled "${label}" was closed` )
                                                            }
                                                            else
                                                            {
                                                                log.info( 'Unlabeled connection closed')
                                                            }
                                                        }
                                }
                    }
})